import { DialectName } from './dialect-manager';
import { Logger } from './logger';
export type ParseConnectionStringOptions = {
    connectionString: string;
    dialectName?: DialectName;
    envFile?: string;
    logger?: Logger;
};
export type ParsedConnectionString = {
    connectionString: string;
    inferredDialectName: DialectName;
};
/**
 * Parses a connection string URL or loads it from an environment file.
 * Upon success, it also returns which dialect was inferred from the connection string.
 */
export declare class ConnectionStringParser {
    #private;
    parse(options: ParseConnectionStringOptions): ParsedConnectionString;
}
