"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DialectManager = void 0;
const dialects_1 = require("../dialects");
/**
 * Returns a dialect instance for a pre-defined dialect name.
 */
class DialectManager {
    getDialect(name) {
        switch (name) {
            case 'mysql':
                return new dialects_1.MysqlDialect();
            case 'postgres':
                return new dialects_1.PostgresDialect();
            case 'libsql':
                return new dialects_1.LibSqlDialect();
            default:
                return new dialects_1.SqliteDialect();
        }
    }
}
exports.DialectManager = DialectManager;
//# sourceMappingURL=dialect-manager.js.map